unit BatchGenMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ListBox1: TListBox;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Label2: TLabel;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    Button2: TButton;
    CheckBox3: TCheckBox;
    Edit2: TEdit;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    Edit3: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label8: TLabel;
    Edit4: TEdit;
    CheckBox4: TCheckBox;
    Button3: TButton;
    Edit5: TEdit;
    Edit6: TEdit;
    Label9: TLabel;
    Edit7: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Memo2: TMemo;
    CheckBox5: TCheckBox;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Button4: TButton;
    Button5: TButton;
    Memo3: TMemo;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Edit13: TEdit;
    Label19: TLabel;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Edit14: TEdit;
    Edit15: TEdit;
    Label24: TLabel;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    ComboBox2: TComboBox;
    TrackBar1: TTrackBar;
    ButtonPrev: TButton;
    ButtonNext: TButton;
    OpenDialog1: TOpenDialog;
    Label25: TLabel;
    Memo5: TMemo;
    Memo1: TMemo;
    Label12: TLabel;
    Button6: TButton;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    procedure ButtonPrevClick(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  InFNDir, OutFNDir, AppDir : string;

function UpCaseStr (TStr : string) : string;


implementation

{$R *.dfm}

function UpCaseStr (TStr : string) : string;
    var i, L : integer; TStr1 : string;
  begin
    L := Length (TStr); TStr1 := '';
    for i := 1 to L do TStr1 := TStr1 + UpCase (TStr [ i ]);
    UpCaseStr := TStr1;
  end;

procedure TForm1.ButtonPrevClick(Sender: TObject);
begin
  if PageControl1.ActivePageIndex = 0
     then PageControl1.ActivePageIndex := PageControl1.PageCount - 1
     else PageControl1.ActivePageIndex := PageControl1.ActivePageIndex - 1;
end;

procedure TForm1.ButtonNextClick(Sender: TObject);
begin
  if PageControl1.ActivePageIndex = PageControl1.PageCount - 1
     then PageControl1.ActivePageIndex := 0
     else PageControl1.ActivePageIndex := PageControl1.ActivePageIndex + 1;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Button1Click(Sender: TObject);
  var i : integer; TStr : string;
begin
  OpenDialog1.Filter := 'All Files|*.*|QuickTime movies|*.mov; *.qt';
  OpenDialog1.Options := OpenDialog1.Options + [ofAllowMultiSelect];
  if OpenDialog1.Execute then
     begin
      ListBox1.Items := OpenDialog1.Files;
      InFNDir := ExtractFileDir (ListBox1.Items.Strings [0]);
      OutFNDir := InFNDir;
      for i := 0 to ListBox1.Items.Count - 1 do
          begin
            TStr := ExtractFileName (ListBox1.Items.Strings [i]);
            ListBox1.Items.Strings [i] := TStr;
          end;
      ListBox1.SelectAll;
      Label25.Caption := 'File to process: ' +
                         IntToStr (ListBox1.Items.Count);
     end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if OutFNDir = '' then OutFNDir := GetCurrentDir;
  if (Edit1.Text = '') or CheckBox2.Checked then
     {if SelectDirectory ('Select desired output directory',
                         ExtractFileDrive (GetCurrentDir), OutFNDir) }
     if SelectDirectory (OutFNDir, [sdAllowCreate, sdPerformCreate, sdPrompt], 0)
        then begin
               Edit1.Text := OutFNDir;
               if not CheckBox2.Checked then CheckBox2.Checked := True;
             end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked and (Edit1.Text = '')
     then Button2Click (Button2 as TButton);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  if Edit2.Text = '' then Edit2.SetFocus;
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
  if Edit2.Text = '' then CheckBox3.Checked := False
                     else CheckBox3.Checked := True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  OpenDialog1.Filter := 'Executables|*.exe; *.com|DOS batch|*.bat|' +
                        'VB scripts|*.vbs|Java|*.java; *.js|All Files|*.*';
  OpenDialog1.Options := OpenDialog1.Options - [ofAllowMultiSelect];
  if OpenDialog1.Execute then
     begin
       AppDir := ExtractFileDir (OpenDialog1.FileName);
       Edit4.Text := ExtractFileName (OpenDialog1.FileName);
       if Pos ('.VBS', UpCaseStr (Edit4.Text)) <> 0
          then Edit4.Text := 'CScript.exe '+ Edit4.Text;
       if Pos ('.JAVA', UpCaseStr (Edit4.Text)) <> 0
          then Edit4.Text := 'java '+ Edit4.Text;
     end;
end;

procedure TForm1.Button4Click(Sender: TObject);
  var fOut : TextFile; i, CBy, TBy : Integer;
      StrBef, StrInF, StrOutF, StrPar : string;
      f : file of Byte;
begin
  Button4.Enabled := False; Button5.Enabled := False;
  AssignFile (fOut, Edit3.Text);
  ReWrite (fOut);

  InFNDir := IncludeTrailingPathDelimiter (InFNDir);
  OutFNDir := IncludeTrailingPathDelimiter (OutFNDir);
  AppDir := IncludeTrailingPathDelimiter (AppDir);

  if CheckBox11.Checked then
     begin
       TBy := 0; CBy := 0;
       for i := 0 to ListBox1.Items.Count - 1 do
           begin
             StrBef := InFNDir + ListBox1.Items.Strings [ i ];
             AssignFile (f, StrBef); ReSet (f);
             TBy := TBy + FileSize (f);
             CloseFile (f);
           end;
     end;

  for i := 0 to ListBox1.Items.Count - 1 do
//      if ListBox1.Selected [ i ] then { something bizzare is going on here }
         begin
           StrBef := ''; StrInF := ''; StrOutF := ''; StrPar := '';
           { For size done }
           if CheckBox11.Checked then
              begin
                AssignFile (f, InFNDir + ListBox1.Items.Strings [i]);
                ReSet (f);
                CBy := CBy + FileSize (f);
                CloseFile (f);
              end;
           { Main }
           if ComboBox1.ItemIndex = 0 then { General Tab }
              begin
                if CheckBox4.Checked then StrBef := StrBef + AppDir;
                StrBef := StrBef + Edit4.Text + ' ' + Edit5.Text + ' ';

                StrInF := StrInF + Edit7.Text;
                if (Edit7.Text <> '') and CheckBox5.Checked
                   then StrInF := StrInF + ' ';
                StrInf := StrInf + Edit8.Text;
                if CheckBox1.Checked then StrInF := StrInF + InFNDir;
                StrInF := StrInF + ListBox1.Items.Strings [ i ];
                StrInF := StrInF + Edit9.Text + ' ';

                if (CheckBox7.Checked) or   //output - different name
                   (CheckBox2.Checked) or   //same name, different dir
                   (Edit10.Text <> '')      //empty parameter
                then
                   begin
                     StrOutF := StrOutF + Edit10.Text;
                     if (Edit10.Text <> '') and CheckBox6.Checked
                        then StrOutF := StrOutF + ' ';
                     StrOutF := StrOutF + Edit11.Text;
                     if CheckBox2.Checked
                        then StrOutF := StrOutF + OutFNDir
                        else if CheckBox1.Checked
                                then StrOutF := StrOutF + InFNDir;
                     StrOutF := StrOutF + ListBox1.Items.Strings [ i ];           
                     if CheckBox7.Checked then
                        StrOutF := ChangeFileExt (StrOutF, Edit2.Text);
                     StrOutF := StrOutF + Edit12.Text + ' ';
                   end;
                 StrPar := Edit6.Text;
            end  { General }
            else begin     { MOV2AVI tab }
                   StrBef := 'mov2avi ';
                   StrInF := '"';
                   if CheckBox1.Checked then StrInF := StrInF + InFNDir;
                   StrInF := StrInF + ListBox1.Items.Strings [ i ] + '" ';
                   StrOutF := '';
                   StrPar := StrPar + '-c' + Edit13.Text;
                   StrPar := StrPar + ' -q' + IntToStr (TrackBar1.Position);
                   case ComboBox2.ItemIndex of
                        0 : StrPar := StrPar + ' -d1';
                        1 : StrPar := StrPar + ' -d2';
                        2 : StrPar := StrPar + ' -d4';
                        3 : StrPar := StrPar + ' -d8';
                        4 : StrPar := StrPar + ' -d16';
                        5 : StrPar := StrPar + ' -d24'
                        else StrPar := StrPar + ' -d32'
                   end;
                   if Edit14.Text <> ''
                      then StrPar := StrPar + ' -f' + Edit14.Text;
                   if CheckBox8.Checked
                      then StrPar := StrPar + ' -g';
                   if CheckBox9.Checked
                      then StrPar := StrPar + ' -w';
                   if Edit15.Text <> ''
                      then StrPar := StrPar + ' -r' + Edit15.Text;
                   if Edit16.Text <> ''
                      then StrPar := StrPar + ' -s' + Edit16.Text;
                   if Edit17.Text <> ''
                      then StrPar := StrPar + ' -h' + Edit17.Text;
                   if (Edit18.Text <> '') or (Edit19.Text <> '') then
                      begin
                        if Edit18.Text = '' then Edit18.Text := '0';
                        StrPar := StrPar + ' -t' + Edit18.Text + ':' +
                                  Edit19.Text;
                      end;
                 end;  { MOV2AVI }
            WriteLn (fOut, StrBef + StrInF + StrOutF + StrPar);
            { Adding echos }
            StrBef := '';
            if CheckBox10.Checked then
               StrBef := 'echo Processed file no. ' + IntToStr (i + 1) +
                         ' of ' + IntToStr (ListBox1.Items.Count);
            if CheckBox11.Checked then
               StrBef := StrBef + ' : ' + IntToStr (Round (100 * CBy / TBy)) +
                         'percent [' + IntToStr (Cby) + '/' + IntToStr (TBy) + ' By]';
            if StrBef <> '' then
               WriteLn (fOut, StrBef);
          end; { selected at ListBox }
  CloseFile (fOut);
  Button4.Enabled := True; Button5.Enabled := True;
end;

procedure TForm1.Button6Click(Sender: TObject);
  var i : Integer;
      StrBef, StrInF, StrOutF, StrPar : string;
      TStrBox : array [ 0 .. 1 ] of string;
begin
  if ListBox1.Items.Count = 0 then
     begin
       TStrBox [ 0 ] := 'a_foo.bin';
       TStrBox [ 1 ] := 'z_foo.bin';
     end
     else begin
            TStrBox [ 0 ] := ListBox1.Items.Strings [ 0 ];
            TStrBox [ 1 ] := ListBox1.Items.Strings [ ListBox1.Items.Count - 1 ];
          end;

  InFNDir := IncludeTrailingPathDelimiter (InFNDir);
  OutFNDir := IncludeTrailingPathDelimiter (OutFNDir);
  AppDir := IncludeTrailingPathDelimiter (AppDir);

  for i := 0 to 1 do
      if not ( (ComboBox1.ItemIndex = 0) and (Edit4.Text = '') ) then
         begin
           StrBef := ''; StrInF := ''; StrOutF := ''; StrPar := '';
           if ComboBox1.ItemIndex = 0 then { General Tab }
              begin
                if CheckBox4.Checked then StrBef := StrBef + AppDir;
                StrBef := StrBef + Edit4.Text + ' ' + Edit5.Text + ' ';

                StrInF := StrInF + Edit7.Text;
                if (Edit7.Text <> '') and CheckBox5.Checked
                   then StrInF := StrInF + ' ';
                StrInf := StrInf + Edit8.Text;
                if CheckBox1.Checked then StrInF := StrInF + InFNDir;
                StrInF := StrInF + TStrBox [ i ];
                StrInF := StrInF + Edit9.Text + ' ';

                if (CheckBox7.Checked) or   //output - different name
                   (CheckBox2.Checked) or   //same name, different dir
                   (Edit10.Text <> '')      //empty parameter
                then
                   begin
                     StrOutF := StrOutF + Edit10.Text;
                     if (Edit10.Text <> '') and CheckBox6.Checked
                        then StrOutF := StrOutF + ' ';
                     StrOutF := StrOutF + Edit11.Text;
                     if CheckBox2.Checked
                        then StrOutF := StrOutF + OutFNDir
                        else if CheckBox1.Checked
                                then StrOutF := StrOutF + InFNDir;
                     StrOutF := StrOutF + TStrBox [ i ];           
                     if CheckBox7.Checked then
                        StrOutF := ChangeFileExt (StrOutF, Edit2.Text);
                     StrOutF := StrOutF + Edit12.Text + ' ';
                   end;
                 StrPar := Edit6.Text;
            end  { General }
            else begin     { MOV2AVI tab }
                   StrBef := 'mov2avi ';
                   StrInF := '"';
                   if CheckBox1.Checked then StrInF := StrInF + InFNDir;
                   StrInF := StrInF + TStrBox [ i ] + '" ';
                   StrOutF := '';
                   StrPar := StrPar + '-c' + Edit13.Text;
                   StrPar := StrPar + ' -q' + IntToStr (TrackBar1.Position);
                   case ComboBox2.ItemIndex of
                        0 : StrPar := StrPar + ' -d1';
                        1 : StrPar := StrPar + ' -d2';
                        2 : StrPar := StrPar + ' -d4';
                        3 : StrPar := StrPar + ' -d8';
                        4 : StrPar := StrPar + ' -d16';
                        5 : StrPar := StrPar + ' -d24'
                        else StrPar := StrPar + ' -d32'
                   end;
                   if Edit14.Text <> ''
                      then StrPar := StrPar + ' -f' + Edit14.Text;
                   if CheckBox8.Checked
                      then StrPar := StrPar + ' -g';
                   if CheckBox9.Checked
                      then StrPar := StrPar + ' -w';
                   if Edit15.Text <> ''
                      then StrPar := StrPar + ' -r' + Edit15.Text;
                   if Edit16.Text <> ''
                      then StrPar := StrPar + ' -s' + Edit16.Text;
                   if Edit17.Text <> ''
                      then StrPar := StrPar + ' -h' + Edit17.Text;
                   if (Edit18.Text <> '') or (Edit19.Text <> '') then
                      begin
                        if Edit18.Text = '' then Edit18.Text := '0';
                        StrPar := StrPar + ' -t' + Edit18.Text + ':' +
                                  Edit19.Text;
                      end;
                 end;  { MOV2AVI }
            TStrBox [ i ] := StrBef + StrInF + StrOutF + StrPar;
          end; { selected at ListBox }
  Label12.Caption := 'Preview : ' + Edit3.Text;
  Memo1.Clear;
  Memo1.Lines.Add (TStrBox [ 0 ]);
  Memo1.Lines.Add ('...');
  Memo1.Lines.Add (TStrBox [ 1 ]);
end;

end.
